#ifndef TRIANGLE_H
#define TRIANGLE_H

#include <QWidget>
#include <QtOpenGL>
#include <QTimer>
#include <qpainter.h>
#include <ctype.h>
#include "opencv2/opencv.hpp"


//Includes C code files
extern "C" {
#include "matrix.h"
#include "pnm.h"
#include "imgUtils.h"
#include "find_Triangles.h"
}

using namespace cv;
class Escena : public QGLWidget {
private:
    //Opencv frames
    VideoCapture *cap;
    Mat frame;
    Mat grayFrame;
    MATRIX *IMG;
    Q_OBJECT // must include this if you use Qt signals/slots
public:
    Escena(QWidget *parent = 0);
    QSizePolicy sizePolicy() const;

    //void getCurrentClass(int *c) {
    //    *c = currentClass;
    //}

    //void getCurrentState(int *s) {
    //    *s = currentState;
    //}

    void draw_IMG();
    void draw_Triangles();
    //void setClass(int classM ){
    //    currentClass = classM;
    //}

public slots:
    void timerDone(void);

    void initscreen(void) {

        timer->start(33);
    }

    void stop(void) {
        timer->stop();
    }

    void capture();
    void classify();


//******************************
signals:
    void trainMsg(); 
    void classMsg();

protected:
    void initializeGL(void);
    void resizeGL(int w, int h);
    void paintGL(void);
    void mouseMoveEvent(QMouseEvent *);
    void keyPressEvent(QKeyEvent * e);

private:
    QTimer *timer;
    int windowWidth, windowHeight; // canvas width and height
    float yrot, xrot; // Encene rotation
    int xmouse, ymouse; // Mouse pointer coordinates

    POINT T1[3], T2[3]; //Triangles point array



    //Centroids
    //double C1[7], C2[7];
    //int NC1, NC2;

    //Class selector // 1 , 2
    //int currentClass;
    
    //int currentState;
};


#endif // CUBO_H
