
#include "imgUtils.h"


/** 
    Dilation of an object
    The resul is save in the same input image
    backgroud = tono
    object = 255
**/
void dilation_4neig_inplace_obj( MATRIX *I, int *v, byte tono )
{
    int i, j;
    byte *ptrin;
    byte **pimg;
    int val;

    // El "borde" a 255 
    /*
    ptrin = (byte *) I->ptr[ v[INICIOY] - 1 ] + v[INICIOX] - 1;
    for( j=v[INICIOX]-1; j<=v[FINX]+1; j++ )
        *ptrin++ = 255;

    for( i=v[INICIOY]; i<=v[FINY]; i++ ) {
        ptrin = (byte *) I->ptr[i] + v[INICIOX] - 1;
        *ptrin = 255;
        ptrin = (byte *) I->ptr[i] + v[FINX] + 1;
        *ptrin = 255;
    }

    ptrin = (byte *) I->ptr[ v[FINY] + 1 ] + v[INICIOX] - 1;
    for( j=v[INICIOX]-1; j<=v[FINX]+1; j++ )
        *ptrin++ = 255;
    */
    // Fin de poner orden. Ok

    pimg = (byte **) I->ptr;
    for( i=v[INICIOY]; i<=v[FINY]; i++ ) {
        ptrin = (byte *) I->ptr[i] + v[INICIOX];
        for( j=v[INICIOX]; j<=v[FINX]; j++ ) {
            if ( *ptrin == tono ) {
                val = 0;
                if ( pimg[i-1][j] == 255 ) val = 255; 
                if ( pimg[i][j-1] == 255 ) val = 255; 
                if ( pimg[i][j+1] == 255 ) val = 255; 
                if ( pimg[i+1][j] == 255 ) val = 255; 

                if ( val == 255 )
                    pimg[i][j] = 254;
            }
            ptrin++;
        }
    }
}


// --------------------
// Negates binary image
void negate( MATRIX *IMG )
{
    byte *px;
    for (int i = 0; i < IMG-> rows; i++)
    {   
        px = (byte *) IMG-> ptr[i];
        for (int j = 0; j < IMG-> cols; j++){
            *px = ((*px) == 255)? 0:255;
            px++;
        }
    }
}

// --------------------
// Clean clean!
void cleanBorder( MATRIX *IN,  int Radius )
{
    int i, j ;
    byte *ptrin;
    /** limpio del borde de la imagen  **/
    
    //Horizontal
    for (int k = 0; k < Radius; ++k)
    {   
    ptrin = (byte *) IN->ptr[0 + k];
    for( j=0; j<IN->cols; j++ ) *ptrin++ = 255;
    
    ptrin = (byte *) IN->ptr[ IN->rows - 1 -k ];
    for( j=0; j<IN->cols; j++ ) *ptrin++ = 255;
    }
    
    //Vertical
    for (int k = 0; k < Radius; ++k)
    {
    for( i=1; i<IN->rows-1; i++ ){
        ptrin = (byte *) IN->ptr[i] + k ;
        *ptrin = 255;
        ptrin = (byte *) IN->ptr[i] + IN->cols - 1 - k ;
        *ptrin = 255;
    }
    }
    
    
}


// --------------------
// Binarizes image given an umbral
void umbral( MATRIX *IMG, int umbral)
{
    byte *px;
    for (int i = 0; i < IMG-> rows; i++)
    {   
        px = (byte *) IMG-> ptr[i];
        for (int j = 0; j < IMG-> cols; j++){
            *px = ((*px) > umbral)? 255:0;
            px++;
        }
    }
}






/** 
 * Calculate a distance map 
 * using the chamfer 3-4, this is an window
 * of size 3x3 which with local calculations
 * aproximate (withing a error of 8%) to the 
 * Euclidian distance
 * 
**/
void chamfer34( MATRIX *IN )
{
	int i, j, l, k, m;
	byte *ptrin, *ptrout;
	int val1[6] = { 4, 3, 4,   3, 0, 255};
	int val2[6] = { 4, 3, 4, 255, 0, 3  };
	int r[6];

	/** limpio del borde de la imagen  **/
    ptrin = (byte *) IN->ptr[0];
    for( j=0; j<IN->cols; j++ ) *ptrin++ = 0;
    ptrin = (byte *) IN->ptr[ IN->rows - 1 ];
    for( j=0; j<IN->cols; j++ ) *ptrin++ = 0;

    for( i=1; i<IN->rows-1; i++ ){
        ptrin = (byte *) IN->ptr[i];
        *ptrin = 0;
        ptrin = (byte *) IN->ptr[i] + IN->cols - 1;
        *ptrin = 0;
    }
    /** termin de limpiar **/


	/** the result is stored in the same input image **/
	/** Forward mask**/
	for( i=0; i<=IN->rows - 3; i++ ) {
		ptrout = (byte *) IN->ptr[i+1] + 1;
		for( j=0; j<=IN->cols - 3; j++ ) {
			for( l=0; l<2; l++ ) { 
				ptrin = (byte *) IN->ptr[i + l] + j;
				for( k=0; k<3; k++ ) {
					m = 3*l + k;
				   	r[m] = *ptrin +  val1[m]; 
					ptrin++;
				}
			}
			m = r[0];
			for( k=1; k<5; k++ ) 
				if ( r[k] < m ) m = r[k]; 

			if ( m > 255 ) m = 255;
			*ptrout++ = m;	
		}
	}
	/** Backward mask **/
	for( i=IN->rows-1; i>=2; i-- ) {
		ptrout = (byte *) IN->ptr[i-1] + IN->cols - 2;
		for( j=IN->cols-1; j>=2; j-- ) {
			for( l=1; l>=0; l-- ) { 
				ptrin = (byte *) IN->ptr[i - l] + j - 2;
				for( k=0; k<3; k++ ) {
					m = 3*l + k;
				   	r[m] = *ptrin++ +  val2[m]; 
				}
			}
			m = r[0];
			for( k=1; k<=5; k++ ) 
				if ( r[k] < m ) m = r[k]; 

			if ( m > 255 ) m = 255;

			*ptrout-- = m;	
		}
	}
}

MATRIX *convolution( MATRIX *img, MATRIX *win, int kw )
{
	MATRIX *OUT;
	int i, j, k, l, s;
	int sum, val;
	byte *ptrin, *ptrout;
	int *ptrw;

	OUT = matrix_allocate( img->rows, img->cols, sizeof(byte) );
	if ( OUT==NULL ) {
		fprintf( stderr, "ERROR allocating memory for output image\n" );
		return NULL;
	}
	for ( i=0; i < img->rows; i++ ) {
		ptrout = (byte *) OUT->ptr[i];
		for ( j=0; j < img->cols; j++ ) 
			*ptrout++ = 0;
	}

	/** Suponemos que la ventana es cuadrada y de taqmao impar **/
	k = win -> rows / 2;

	for ( i=0; i <= img->rows - win->rows; i++ ) {
		ptrout = (byte *) OUT->ptr[i + k] + k;

		for ( j=0; j <= img->cols - win->cols; j++ ) {
			sum = 0;
			for ( l=0; l < win->rows; l++ ) {
				ptrin = (byte *)img->ptr[ i + l ] + j;
				ptrw = (int *)win->ptr[ l ];
				for ( s=0; s < win->cols; s++ ) 
					sum += *ptrin++ * *ptrw++;
			}
			val = (int)( (1.0/kw)*sum + 0.5 );
			*ptrout++ = (val<0) ? 0 : (val>255) ? 255 : (byte)val;
		}
	}

	return OUT;	
}
	

void smoothIMG(MATRIX *IMG)
{  
	//printf("Starting smoothing... \n");

    //2 - Smoothing (2 Pass)
        MATRIX *IN, *FIL;

        int **fil;
        FIL = matrix_allocate( 3, 3, sizeof( int ) );
        if ( FIL==NULL ) {
            fprintf( stderr, "ERROR allocating memory\n" );
            return ;
        }

        //Smooth Window
        fil = (int **)FIL->ptr;
        fil[0][0] = 1; fil[0][1] = 1; fil[0][2] = 1;
        fil[1][0] = 1; fil[1][1] = 1; fil[1][2] = 1;
        fil[2][0] = 1; fil[2][1] = 1; fil[2][2] = 1;

        //printf("SIZE of matrix rows= %d, cols=%d.... = %d \n", IMG->rows,IMG->cols,IMG->rows* IMG->cols * sizeof(byte));
        //IN = convolution( IMG, FIL, 9 );    //1st Pass
		//	write_pnm( IMG, "convol1.pgm" );

        //memcpy( IN, IMG, sizeof(MATRIX) );
        //IMG = convolution( IN, FIL, 9 );  //2nd Pass
                //write_pnm( IMG, "convol2.pgm" );

    	
    //3 - Binarize IMG global threshold 
        umbral( IMG, 90 );
        		//write_pnm( IMG, "BINARIZE.pgm" );


    //4 - Opening / Erotion->Dilatation
    int Umbral = 2;
            //Opening
            //Erosion
            negate( IMG );
            chamfer34( IMG ); 
            umbral( IMG , Umbral );
            negate( IMG );
                    //write_pnm( IMG, "EROTION.pgm" );
            //Dilatation
            chamfer34( IMG );
            umbral( IMG , Umbral );
                    //write_pnm( IMG, "DILATATION.pgm" );
            cleanBorder( IMG , Umbral );
                    //write_pnm( IMG, "OPENING.pgm" );


    //matrix_free( IMG );
	//matrix_free( IN );
	matrix_free( FIL );

}

