#include "painter.h"
#include "escena.h"

Painter::Painter(QWidget *parent)
: QWidget(parent) {

    QPushButton *quit = new QPushButton(tr("Quit"));
    quit->setFont(QFont("Arial", 14, QFont::Bold));
    connect(quit, SIGNAL(clicked()), qApp, SLOT(quit()));

    scene = new Escena(this);
    connect(scene, SIGNAL(trainMsg()), SLOT(newTrainMsg()));
    connect(scene, SIGNAL(classMsg()), SLOT(newClassMsg()));

    myinit = new QPushButton(tr("InitCam"));
    myinit->setFont(QFont("Arial", 13, QFont::Bold));
    connect(myinit, SIGNAL(clicked()), scene, SLOT(initscreen()));

    stop = new QPushButton(tr("StopCam"));
    stop->setFont(QFont("Arial", 13, QFont::Bold));
    connect(stop, SIGNAL(clicked()), scene, SLOT(stop()));

    //----
    // TRAIN
    capture = new QPushButton(tr("Capture"));
    capture->setFont(QFont("Arial", 12, QFont::Bold));
    connect(capture, SIGNAL(clicked()), scene, SLOT(capture()));





    //classify = new QPushButton(tr("Classify"));
    //classify->setFont(QFont("Arial", 13, QFont::Bold));
    //connect(classify, SIGNAL(clicked()), scene, SLOT(classify()));

    //save = new QPushButton(tr("SaveClasses"));
    //save->setFont(QFont("Arial", 7, QFont::Bold));
    //connect(save, SIGNAL(clicked()), scene, SLOT( save() ) );

    //read = new QPushButton(tr("ReadClasses"));
    //read->setFont(QFont("Arial", 7, QFont::Bold));
    //connect(read, SIGNAL(clicked()), scene, SLOT( read() ) );

    //reset = new QPushButton(tr("ResetData"));
    //reset->setFont(QFont("Arial", 7, QFont::Bold));
    //connect(reset, SIGNAL(clicked()), scene, SLOT( reset() ) );



    

    messTrain = new QLabel();
    messTrain->setMaximumHeight(20);
    messTrain->setFrameStyle(QFrame::WinPanel | QFrame::Sunken);
    // messTrain->setBackgroundColor( messTrain->colorGroup().base() );
    messTrain->setAlignment(Qt::AlignCenter);

    messTrain->setText( "MESSTRAIN");


    messClass = new QLabel();
    messClass->setMaximumHeight(20);
    messClass->setFrameStyle(QFrame::WinPanel | QFrame::Sunken);
    // messClass->setBackgroundColor( messpos->colorGroup().base() );
    messClass->setAlignment(Qt::AlignCenter);
    messClass->setText( "MESSCLASS");



//////////////////////////////////////////////////

    scene->setMinimumSize(640, 480);

    QGridLayout *grid = new QGridLayout(); //2x2, 5 pixel border
    grid->addWidget(scene, 0, 1);
    grid->setColumnStretch(1, 10);

 //////////////////////////////////////////

    QVBoxLayout *leftBox = new QVBoxLayout;
    grid->addLayout(leftBox, 0, 0);

    leftBox->addWidget(myinit);
    leftBox->addWidget(stop);

    //leftBox->addWidget(C1);
    //leftBox->addWidget(C2);
    leftBox->addWidget(capture);
    leftBox->addWidget(messTrain);


    //leftBox->addWidget(classify);
    leftBox->addWidget(messClass);

    //leftBox->addWidget(save);
    //leftBox->addWidget(read);
    //leftBox->addWidget(reset);


    //leftBox->addWidget(visorMouse);
    //leftBox->addWidget(visorTama);

    leftBox->addWidget(quit);

    setLayout(grid);
}

void Painter::newTrainMsg() {
    int CClass;

    //scene->getCurrentClass(&CClass);

    QString s;

    if(CClass == 0)
        messTrain->setText( s.sprintf("First select a CLASS!"));
    else
        messTrain->setText( s.sprintf("Class [%d] updated", CClass ));
}

void Painter::newClassMsg() {
    int state;

    //scene->getCurrentState(&state);

    QString s  = "<b>";
    
    switch(state){
        case 0:  s.append( "<FONT COLOR='#333333' FONT SIZE = 1> To CLASSIFY first TRAIN/READ..." ); break;
        case 1:  s.append( "<FONT COLOR='#ee2525' FONT SIZE = 3> CLASS 1" ); break;
        case 2:  s.append( "<FONT COLOR='#11bb44' FONT SIZE = 3> CLASS 2" ); break;
        case -1: s.append( "<FONT COLOR='#333333' FONT SIZE = 2> Saved..." ); break;
        case -2: s.append( "<FONT COLOR='#333333' FONT SIZE = 2> Reading Classes..." ); break;
        case -3: s.append( "<FONT COLOR='#333333' FONT SIZE = 2> Classes Resetted..." ); break;

        default: s.append( "<FONT COLOR='#288bac' FONT SIZE = 3> !!UNKNOWN!!" ); break;
    }

    //messClass->setText(s.sprintf("State= %d ", state));


    s.append("</b>");
    messClass->setText(s);

}

void Painter::selectClass1()
{
    //QString s;
    //messTrain->setText(s.sprintf("The button was %d", 1));

    //scene->setClass( 1 );
}

void Painter::selectClass2()
{
    //QString s;
    //messTrain->setText(s.sprintf("The button was %d", 2));
    //scene->setClass( 2 );

}